# Backend internal interview (rust) - main

A **Refactor metric-consumer** task

> [!Tip]
> Use [Improve branch](/NewRelic/be-technical-interview-rust/src/branch/improved) as a full refactoring for <u>better quality, maintenance and readability</u>. (Structs, implementaitions, settings for multiple inputs, etc).

[Home Task exercise description](Home-Task_exercise_interview_Rust.pdf)

> [!CAUTION]
> This branch does not have any change, it has original content.

## Proposal for review

> There are several branches developed as proposal:

 - [Basic fixed one](/NewRelic/be-technical-interview-rust/src/branch/basic-fixed)

  > A basic code review, fixed with minor and essential changes to work as expected.

  > Tests are included for verification.

- [Improve one](/NewRelic/be-technical-interview-rust/src/branch/improved)

- [x]  Define a basic model, easily to extend and modify. **Abstraction / Generic**.
- [x]  Structs and implementations to specific metricis traitments. **Modular appoach**.
- [x]  Settings and configuration for interactive and non interactive processing (batch mode) **Customize on context**.